---
title: 树莓派-花生壳-内网穿透
tags:
  - 花生壳  
  - 内网穿透
categories:
  - 树莓派
password: 209445
comments: true
abbrlink: 3ac023e7
date: 2018-09-01 23:53:13
images: http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE-%E8%8A%B1%E7%94%9F%E5%A3%B3-%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F/%E6%A0%91%E8%8E%93%E6%B4%BE+%E8%8A%B1%E7%94%9F%E5%A3%B3.png
---
## 远程访问树莓派
树莓派一般都是接在路由器下面的，当然是内网啦，在外面的时候是访问不了的，这时候就需要[内网穿透](http://service.oray.com/question/5571.html)才能实现外网依然能够访问到树莓派。内网穿透的软件网上有很多，这里选择花生壳，貌似挺有名的。

## 花生壳注册
官网[https://hsk.oray.com/](https://hsk.oray.com/).
1. 打开之后在右上角有登录注册。
2. 点击注册，同意隐私政策，填写账号密码手机号，按照正常流程走就OK了。貌似后续是会提示你进行实名制的，嫌麻烦可以不用实名制拍照上传啥的,不操作这一步。
3. 注册成功会送你一个免费的花生壳域名用作以后使用，你也可以免费注册一个自定义的壳域名，不过后缀是指定的。
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE-%E8%8A%B1%E7%94%9F%E5%A3%B3-%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F/%E6%B3%A8%E5%86%8C%E6%88%90%E5%8A%9F.png)

## 安装树莓派花生壳客户端
下载最新安装包[https://hsk.oray.com/download](https://hsk.oray.com/download)，选择树莓派下载。也可以通过SSH运行下面命令直接获得并安装。
```
cd /home/pi/Documents && mkdir hskoray && cd hskoray  //创建下载目录
wget  https://hsk.oray.com/download/download?id=25 -O phddns_rapi.armhf.deb //下载
sudo dpkg -i phddns_rapi.armhf.deb //安装
```
安装完毕会输出SN码和默认的登录密码，这个需要保存一下SN码，之后添加设备需要用到。
```
pi@BeGild_Raspi:~/Documents/hskoray $ sudo dpkg -i phddns_rapi_3.0.1.armhf.deb
正在选中未选择的软件包 phddns。
(正在读取数据库 ... 系统当前共安装有 129540 个文件和目录。)
正准备解包 phddns_rapi_3.0.1.armhf.deb  ...
正在解包 phddns (3.0.2) ...
正在设置 phddns (3.0.2) ...
2018-09-02 02:32:31     = Debug =       [http_call] attempt to connect server: rapi.ephapi.oray.net/device/register
2018-09-02 02:32:31     = Debug =       [http_call] create new stream because alive streams is empty.
2018-09-02 02:32:31     - Info  -       [http_call] connect server: rapi.ephapi.oray.net:443(121.40.234.27)
  . Performing the SSL/TLS handshake...
 ok
  . Verifying peer X.509 certificate...
 ok
2018-09-02 02:32:32     - Info  -       register ok
SN : RA***cac***4a4**
fastcode=2a868****b29e267****be05ee803a5
SN : RA***cac***4a4**
2018-09-02 02:32:32     - Info  -       [Main] oraysl started as a daemon.
Phddns Service install success.

+--------------------------------------------------+
|             Oray PeanutHull Linux 3.0            |
+--------------------------------------------------+
|  SN: RA***cac***4a4**   Default password: admin  |
+--------------------------------------------------+
|    Remote Management Address http://b.oray.com   |
+--------------------------------------------------+
正在处理用于 systemd (232-25+deb9u4) 的触发器 ...
pi@BeGild_Raspi:~/Documents/hskoray $

```
其余的相关功能命令大致如下，可以通过输入`phddns` 获得。
```
sudo dpkg -r phddns //卸载花生壳
phddns start（启动）| stop（停止）| restart（重启）
phddns status（状态）| version（版本）|reset（重置）
```
日志保存在`/var/log/phddns`目录下。官方的教程见[花生壳 3.0 for 树莓派 安装使用攻略](http://service.oray.com/question/2680.html)

## 绑定设备
绑定需要先登录远程管理设备页面。点击[https://b.oray.com/](https://b.oray.com/)，打开远程管理页面，输入刚生成的树莓派的SN码，输入默认密码admin进行登录。第一次登陆会让你完善信息填写手机号等信息。
登录之后会提示你这个是内部的账号需要和你刚注册的账号进行”绑定”。点击`立即切换`即可切换到登录界面,输入你注册的账号和密码登录,设备自然就归属到你的名下了。
[](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE-%E8%8A%B1%E7%94%9F%E5%A3%B3-%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F/%E8%AE%BE%E5%A4%87%E7%BB%91%E5%AE%9A.png)

## 开通内网穿透
开通内网穿透体验版仅需6元，可以在绑定设备后在[设备管理界面](https://b.oray.com/forward/)点击左边侧栏的内网穿透进行开通.
![](http://upload-cdn.oray.com/upload/help/1806/201806251335371098.png)
也可以在[首页](https://hsk.oray.com/)左下角点击进入开通页面开通.
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE-%E8%8A%B1%E7%94%9F%E5%A3%B3-%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F/%E5%BC%80%E9%80%9A%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F.png)

## ~~路由器打开DDNS~~
emmm我看别人的教程都没说要设置DDNS了，但是我的不设置的话就不成功。所以这里有待考究[2018.10.04]这里找客服咨询过来，不需要设置路由器 DDNS ，不仅如此，如果设置了DDNS花生壳会提示账号重复登录的问题，之前不成功的原因是因为需要一定的刷新(映射？)时间。
- 设置过程就是在浏览器输入路由器管理地址，一般就是`192.168.1.0`或者`192.168.1.1`，输入管理员密码登录，我的是TPLINK WR855N，是支持DDNS的。
- 登录之后的页面里选择应用管理-> DDNS 进入，在服务提供者选择花生壳，输入自己的账号和密码勾选自动登录然后登录就OK了。
- 对了这里建议使用路由器的IP和MAC地址绑定应用，将IP固定分配给树莓派，这样树莓派在内网的IP就固定了.
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE-%E8%8A%B1%E7%94%9F%E5%A3%B3-%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F/TPLINK%E8%AE%BE%E7%BD%AEDDNS.png)  

## 添加端口映射
开通了端口映射之后，在端口映射页面右边会出现一个增加端口映射的按钮。点击即可添加.
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE-%E8%8A%B1%E7%94%9F%E5%A3%B3-%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F/%E6%B7%BB%E5%8A%A0%E7%AB%AF%E5%8F%A3%E6%98%A0%E5%B0%84.png)

## 注册免费的自定义壳域
注册了花生壳账号之后会给一个选一个自定义壳域名的机会。在设备管理页面点击侧边`我的域名`,左上角有个`注册壳域名`.点击之后进入注册界面，写一下自己喜欢的前缀在免费的后缀里选择一个，点击搜索，没有被别人注册的话就可以自注册了。
用这个壳域名添加映射同样可以使用。
## 验证访问
打开SSH软件，新建一个连接填写主机地址(添加映射的壳域名)，端口(花生壳为你分配的随机端口，在[设备管理页面](https://b.oray.com/)->内网穿透->映射列表->壳域名->后可以看到)，输入登录账号pi和你的树莓派密码即可，双击新建的连接，能连接成功就是通了的。
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE-%E8%8A%B1%E7%94%9F%E5%A3%B3-%E5%86%85%E7%BD%91%E7%A9%BF%E9%80%8F/%E5%85%AC%E7%BD%91SSH%E9%AA%8C%E8%AF%81.png)

## 后记
经过上面的一系列步骤树莓派已经可以在外网被访问了，这里端口映射添加的是SSH指定的22端口，当然你也可以根据需要指定其他的端口，不过免费版本的只支持两个端口映射。经过使用，这个为你分配的临时端口其实时间挺长的，不会几小时就变一次，两三天都不变一次的。
可以下载官方的花生壳管理APP,[Android](https://hsk.oray.com/download/download?id=36)/[IOS](https://hsk.oray.com/download/download?id=37)进行管理和查看状态。
