---
title: 树莓派安装系统和配置
tags:
  - 树莓派安装系统
categories:
  - 树莓派
password: 209445
comments: true
abbrlink: fd8be0b3
date: 2018-08-19 13:12:23
images: http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE%E7%B3%BB%E7%BB%9F%E5%AE%89%E8%A3%85%E5%92%8C%E9%85%8D%E7%BD%AE/%E6%A0%91%E8%8E%93%E6%B4%BE%E5%8A%A8%E5%9B%BE.gif
---
最近打算玩一玩树莓派，感觉从毕业之后荒了蛮久没有新的东西注入了。其实有在考虑要不要记录这个安装的过程，因为其实教程已经漫天飞了，有重复造轮子之嫌。不过听说好记性不如烂笔头，记一下方便回顾也很有成就感不是吗？顺便说一下我的机器：树莓派3B+，因为穷，只买了裸板嘤嘤嘤。<!---more--->

## 下载树莓派系统
1. 从官网的下载页面[https://www.raspberrypi.org/downloads/](https://www.raspberrypi.org/downloads/)可以看到树莓派支持的系统有好多种，这里下载官方的 RASPBIAN 系统，这个是基于 Debian 进行开发的。当然你也可以尝试一下 Ubuntu MATE 也蛮不错的。
2. 点击大大的 PASPBIAN 图标可以进入选择下载 PASPBIAN DESKTOP 版还是 Mini 版。这里选择DESKTOP吧，安装好之后可以选择关闭视频输出用 VNC 远程桌面的。
3. 点击 RASPBIAN STRETCH WITH DESKTOP 板块的[Download Zip](https://downloads.raspberrypi.org/raspbian_latest) 按钮即可开始下载。点击->[这里](https://downloads.raspberrypi.org/raspbian_latest)可以下载最新的桌面版 PASPIAN 系统。
4. 下载完成之后就可以开始下一步了，不用解压，就保持为 zip 格式。
## 安装烧录镜像的工具 Etcher
这个工具是linux macOS Windows都可以支持的，比起 Win32DiskImager来，长的还不错，界面也很简单(超级简单)。
1. 去官网[https://etcher.io/](https://etcher.io/) 下载最新版本。
2. 下载完毕之后安装，安装完毕打开就可以使用了。
## 烧写系统镜像
1. 选择你下载的系统镜像文件(.zip)
2. 选择你写的SD卡所在的盘符。
3. 点击 Flash，等待进度的完成。
![etcher使用](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE%E7%B3%BB%E7%BB%9F%E5%AE%89%E8%A3%85%E5%92%8C%E9%85%8D%E7%BD%AE/etcher%E4%BD%BF%E7%94%A8.gif)

烧录完毕之后，SD卡会被分区为两个盘符，一个名字叫 boot(启动分区) 另一个叫 rootfs(根文件系统)。boot分区只有几十M，除去 rootfs 之外剩下的SD卡空间都是未被分配的状态所以 rootfs 只比系统大一点，等启动树莓派之后在树莓派的配置项里选择 SD 卡扩容把整个 SD 卡剩余空间合并到 rootfs 里。
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE%E7%B3%BB%E7%BB%9F%E5%AE%89%E8%A3%85%E5%92%8C%E9%85%8D%E7%BD%AE/%E7%A9%BA%E9%97%B4%E6%9C%AA%E5%88%86%E9%85%8D.png)

## 系统视频输出的配置
这个配置是用于正确输出视频信号给显示器显示，树莓派会自动检测显示器属性自动调整的，当你的显示效果没有达到预期(HDMI->VGA)时可以通过手动配置一下。
配置项在  <font color=#00ffff size=4>/boot/config.txt</font>文件里。打开该配置文件进行修改即可。
关于配置的介绍可以在[这里](http://rpf.io/configtxt)看到。这里的配置需要贴合你显示器的属性，设置的教程可以参照->[自定义树莓派的显示分辨率](http://shumeipai.nxez.com/2013/08/31/custom-display-resolution-raspberry-pie.html) 进行显示器分辨率`hdmi_mode`的调整。我的显示器是2K屏，计算机显示器，配置项如下。
```
# uncomment if you get no picture on HDMI for a default "safe" mode
hdmi_safe=1
# uncomment this if your display has a black border of unused pixels visible
# and your display can output without overscan
disable_overscan=1
# uncomment if hdmi display is not detected and composite is being output
hdmi_force_hotplug=1
# uncomment to force a specific HDMI mode (this will force VGA)
hdmi_group=2
hdmi_mode=76
hdmi_ignore_edid=0xa5000080
# uncomment to force a HDMI mode rather than DVI. This can make audio work in
# DMT (computer monitor) modes
hdmi_drive=2
# uncomment to increase signal to HDMI, if you have interference, blanking, or
# no display
config_hdmi_boost=4
```
配置完毕，插上SD卡、hdmi线、电源即可看到树莓派启动，如果使用的是HDMI转VGA为了保证视频的稳定这里最好使用单独电源供电的转换头。开机显示如下：
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE%E7%B3%BB%E7%BB%9F%E5%AE%89%E8%A3%85%E5%92%8C%E9%85%8D%E7%BD%AE/%E6%A0%91%E8%8E%93%E6%B4%BE%E5%BC%80%E6%9C%BA.jpg)

## 系统选项配置
插上鼠标键盘,启动系统之后打开终端，输入`sudo raspi-config`命令即可进行配置，界面如下。
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE%E7%B3%BB%E7%BB%9F%E5%AE%89%E8%A3%85%E5%92%8C%E9%85%8D%E7%BD%AE/raspi-config.jpg)  
配置界面的详细说明如下：
```  
1. 修改登录密码。
2. 网络选项：
    1. 树莓派在网络上的名字(在路由器管理界面可以看到)
    2. WIFI名称和密码
    3. 网络是否可以被探测。
3. 启动选项：
    1. 启动选择桌面还是控制台，控制台就没有界面黑乎乎的。
       1. 控制台不自动登录
       2. 控制台自动登录
       3. 桌面环境不自动登录
       4. 桌面环境自动登录
    2. 是否在启动是等待网络连接完成。
    3. 是否启用画面过渡。用画面过渡开机过程，还是使用文本过渡(开机的时候刷刷刷的文本启动信息)。
4. 本地化选项：
    1. 选择语言。在弹出的列表里上下移动直至找到 zh_CN.UTF-8 UTF-8。空格进行选择，回车进行确认。
    2. 选择时区。Etc
    3. 选择键盘布局。国际标准105键。
    4. 选择WIFI地区。CN-China
5. 接口选项：这里主要是树莓派对外的接口功能使能。
    1. 摄像头。选择是否使用摄像头。根据需要选择使能。
    2. SSH。选择是否启用SSH进行远程连接。选择使能。
    3. VNC.选择是否启用VNC作为远程桌面连接。根据需要选择使能。
    4. SPI。选择是否启用SPI接口。根据需要选择使能。
    5. IIC。选择是否启用IIC接口。根据需要选择使能。
    6. 串口Serial。选择是否启用串口。根据需要选择使能。
    7. 1-Wire。选择是否启用单线接口。根据需要选择使能。
    8. Remote GPIO。选择是否允许远程控制GPIO。根据需要选择使能。
6. 超频选项：CPU超频。
7. 高级选项：
   1. 扩展SD卡文件系统，也就是在刷入树莓派系统时候会有没分配的空闲空间，通过这个选项就可以将SD卡完全整合起来。
   2. 过扫描选项。如果显示器显示有黑边可以开启这个选项。关于过扫描可以看http://bbs.a9vg.com/thread-2358167-1-1.html。
   3. 修改显卡可用内存大小。默认值64
   4. 声音选项。选择声音的输出方向。
      1. 自动。根据有效的输出源输出。
      2. 通过3.5耳机接口输出
      3. 通过HDMI传输音频。
   5. 分辨率选项。选择特定的分辨率作为输出视频的分辨率。根据显示器配置进行选择。
   6. 像素点加倍选项。选择是否将像素进行2*2映射。我选择之后画面显示不全，很模糊。不知道干嘛用的感觉像是分辨率变低了。
   7. Open GL驱动选项。选择是否启用open GL桌面驱动程序。这个是硬件加速的选项，如果使用桌面可以选择启用该功能。这个选项我其实并没有什么感觉，没有试过。可以看下https://www.jianshu.com/p/2438d2c76cdb。
      1. Full KMS 这个效率更高全部通过内核直接输出，但是兼容性差一些，遇到一些远程桌面软件可能会出问题。
      2. FAKE KMS 该选项兼容性好一些。
      3. 使用软件渲染。不使用Open GL。
8. 升级。检查升级系统。
9. 关于树莓派配置工具的说明。
```
我用的系统2018-06-27-raspbian-stretch是可以通过桌面左上角的小树莓图标->首选项->树莓派配置进行配置的。
配置完毕之后选择 Finish 按钮进行重启，生效更改。
我的配置大致如下：
    修改登录密码、使用控制台自动登录、启用 SSH 和 VNC 、不超频、扩展SD卡、不进行像素点加倍、不使用Open GL(不好意思我只用SSH连接)，另外GPU内存我就按照的默认64M来，之后需要再修改吧。
## 安装中文输入法
虽然之后都是使用SSH进行连接，但是！！！偶尔使用桌面时依然不能忍受没有中文的情况啦。运行下面的三条命令进行安装，最后使用reboot重启系统生效更改。通过 ctrl+space 可以切换。
```
sudo apt-get install fcitx #安装 fctix 输入法框架
sudo apt-get install fcitx-pinyin     # 安装fcitx拼音
sudo apt-get install fcitx-googlepinyin  # 安装google拼音
```
这样就完成了树莓派个性化的配置啦。
## 使用SSH进行树莓派的连接
这里推荐使用Finall shell这个远程连接软件。可以实时监控CPU、内存、磁盘等的使用，可以有命令历史，自动补全等。免费版本已经够使用了。
1. Windows 点击[下载](http://www.hostbuf.com/downloads/finalshell_install.exe)Finall shell最新版本。官网:[http://www.hostbuf.com/](http://www.hostbuf.com/)。官网看起来毫无美感，胜在简单没有广告.
2. 下载之后运行安装。安装完毕打开软件。可以看到一个右边是一些图表栏，用于显示当前系统一些信息。右边是命令行窗口，下面是远程文件管理系统可以用来传输文件。
3. 点击右上角文件夹样式的小图标打开连接管理器，点击左上角白色文件夹加号建立一个SSH连接。
      1. 输入连接名称(标识，方便查看比如：树莓派)。  
      2. 主机，填入树莓派的IP地址。  
          - 这里可以用树莓派运行 `ifconfig` 命令查看ip地址,应该是`192.168.1.*`
          - 也可以通过浏览器输入`192.168.1.1��?92.168.1.0` 进入路由器管理界面查看树莓派的IP地址。
      3. 端口默认22.方法使用密码，用户名为 pi (树莓派默认用户名)，密码为你的登录密码。  
      4. 点击`确定`建立连接成功。
4. 双击新建的连接进行连接，会在主窗口的右边命令行栏新建一个连接分页，连接成功就能看到大致如下的界面。
![](http://begild-one.top/%E6%A0%91%E8%8E%93%E6%B4%BE%E7%B3%BB%E7%BB%9F%E5%AE%89%E8%A3%85%E5%92%8C%E9%85%8D%E7%BD%AE/SSH%E8%BF%9E%E6%8E%A5%E6%A0%91%E8%8E%93%E6%B4%BE.png)
5. 软件的其他个性化配置自行摸索，大致有命令行主题，颜色等的配置吧。点击软件右上角的三条横线图标->选项可以找到。
## 后记
这样就完成树莓派的基本配置和使用了，利用 SSH 整个树莓派只需要连接一根USB电源线就可以愉快的玩耍了，当然这里的电源适配器一定要稳定电流足量(2A以上)，不要拿那种10块钱包邮的电源适配器。
